<?php

namespace RxConnexionBundle\Form;

use Doctrine\Common\Persistence\ObjectManager;
use Doctrine\ORM\EntityRepository;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\TextareaType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\Form\Extension\Core\Type\HiddenType;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\OptionsResolver\OptionsResolver;
use Symfony\Component\Form\FormEvent;
use Symfony\Component\Form\FormEvents;
use RxConnexionBundle\Form\DataTransformer\DataTransformer;

class PatientLetterNoteForm extends AbstractType
{
    private $manager;

    public function __construct(ObjectManager $manager) {
        $this->manager = $manager;
    }

    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder
            ->add('action', HiddenType::class, array(
                'mapped' => false,
                'attr' => array(
                    'class' => 'form-action'
                )
            ))
            ->add('patient_letter', HiddenType::class, array(
                'attr' => array(
                    'value' => $options['patient_letter_id']
                )
            ))
            ->add('id', HiddenType::class)
            ->add('note', TextareaType::class, array(
                'label' => 'Notes',
                'label_attr' => array(
                    'class' => 'middle'
                ),
                'required' => true,
                'attr' => array(
                    'rows' => 5
                )
            ))
            ->add('account_user', HiddenType::class)
            ->addEventListener(FormEvents::PRE_SET_DATA, function(FormEvent $event) {

                $form = $event->getForm();
                $data = $event->getData();
                $accountUser = $data->getAccountUser();

                $form
                    ->add('account_user_desc', TextType::class, array(
                        'label' => 'User',
                        'label_attr' => array(
                            'class' => 'required middle'
                        ),
                        'attr'  => array(
                          'readonly'   => 'false'
                        ),
                        'required' => true,
                        'mapped' => false,
                        'data' => $accountUser ? $accountUser->getFullName() : ''
                    ));
            });

        $builder->get('patient_letter')->addModelTransformer(new DataTransformer($this->manager, 'RxConnexionBundle:PatientLetterEntity', true));
        $builder->get('account_user')->addModelTransformer(new DataTransformer($this->manager, 'RxConnexionBundle:AccountUserEntity', false));
    }

    public function getBlockPrefix()
    {
        return 'patient_letter_note';
    }

    public function configureOptions(OptionsResolver $resolver)
    {
        $resolver->setDefaults(array(
            'data_class' 	  => 'RxConnexionBundle\Entity\PatientLetterNoteEntity',
            'csrf_protection' => true,
            'csrf_field_name' => '_token',
            // a unique key to help generate the secret token
            'intention'       => 'patient_letter_noteEntity_intention',
            'action'          => 'n',
            'patient_letter_id'      => null
        ));
    }
}